<?php

class Appellation{
    /**
     * gestion statique des accès SGBD
     * @var PDO
     */ 
    private static $_pdo;

    /**
     * gestion statique de la requête préparée de selection
     * @var PDOStatement
     */ 
    private static $_pdos_select;

    /**
     * gestion statique de la requête préparée de mise à jour
     *  @var PDOStatement
     */ 
    private static $_pdos_update;

    /**
     * gestion statique de la requête préparée de d'insertion
     * @var PDOStatement
     */ 
    private static $_pdos_insert;

    /**
     * gestion statique de la requête préparée de suppression
     * @var PDOStatement
     */ 
    private static $_pdos_delete;

    /**
     * PreparedStatement associé à un SELECT, calcule le nombre de livres de la table
     * @var PDOStatement;
        */
    private static $_pdos_count;

    /**
     * PreparedStatement associé à un SELECT, récupère tous les livres
     * @var PDOStatement;
        */
     private static $_pdos_selectAll;



    /**
     * Initialisation de la connexion et mémorisation de l'instance PDO dans Appelation::$_pdo
     */ 
    public static function initPDO() {
        require "parametres.php";
        self::$_pdo = new PDO("psql:host=".$db_host.";dbname=".$db_name,$db_user,$db_passwd);
        // pour récupérer aussi les exceptions provenant de PDOStatement
        self::$_pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
    }

    /**
     * préparation de la requête SELECT * FROM livre
     * instantiation de self::$_pdos_selectAll
    */
    public static function initPDOS_selectAll() {
        self::$_pdos_selectAll = self::$_pdo->prepare('SELECT * FROM appelation');
    }

    /**
     * méthode statique instanciant LivreMetier::$_pdo_select
     */ 
    public static function initPDOS_select() {
        self::$_pdos_select = self::$_pdo->prepare('SELECT * FROM appellation WHERE id_appellation= :numero');
    }

    /**
     * initialisation d'un objet métier à partir d'un enregistrement de livre
     * @param $liv_num un identifiant de livre
     * @return l'instance de LivreMetier associée à $liv_num
     */ 
    public static function initAppellation($id_appellation) : Appellation {
        try {
	        if (!isset(self::$_pdo))
	            self::initPDO();
	        if (!isset(self::$_pdos_select))
	            self::initPDOS_select();
	        self::$_pdos_select->bindValue(':numero',$id_appellation);
	        self::$_pdos_select->execute();
        // résultat du fetch dans une instance de LivreMetier
	        $app = self::$_pdos_select->fetchObject('Appellation');
	        if (isset($app) && ! empty($app))
	            $app->setNouveau(FALSE);
	        if (empty($app))
                throw new Exception("Appelation numero $id_appellation inexistante dans la table Appellation.\n");
	        return $app;
        }
        catch (PDOException $e) {
	        print($e);
        }
    }
}
    

?>